// Wank.To.js for PSPTube
// Made By JK108

function WankTo_CheckURL( url, option )
{
	if (url.match("http://www.wank.to/") == "http://www.wank.to/"){
		return 1;
	} else{
		return 0;
	}
}

/*
 Get a WankTo URL
*/
function WankTo_GetURL( url, option )
{
	var contents = GetContents(url);
	if(contents == null){return null; /* failed to get page */}
	var video_url = contents.match(/\tfilename \= \'(.*?)\'/);
	var video_url = video_url[1];
	return video_url;
}

function WankTo_Search( keyword, start_index, length, option )
{
	var result = new Object();
        result.keyword   = keyword;	// Search
	result.VideoInfo = new Array();	// Results in sequence
	result.start     = start_index;	// Index of first result
	result.end       = 0;
	result.total     = -1;
	var perpage = 15;


	result.start = (((result.start - 1) / 10) * perpage) + 1;


	if(result.start < perpage){
	var contents = GetContents("http://www.wank.to/?search=" + keyword.replace(/ /g, "+"));
	} else{
	var num = 1 + ((result.start - 1) / perpage);
	var contents = GetContents("http://www.wank.to/?search=" + keyword.replace(/ /g, "+") + "&page=" + num);
	}
	if(contents == null){return null; /* failed to get page */ }


	if(contents.match("<p align=\"center\"> No Videos yet, come again later! </p>") == "<p align=\"center\"> No Videos yet, come again later! </p>"){result.total = 0; return result;}
	result.total = 10000;


	while(1){
	var pos = contents.indexOf("<td width=\"135\" style=\"color:#0033CC; font-size:8pt;\" valign=\"top\">");

	if(pos != -1){
		contents = contents.substring(pos + 67, contents.length);
		//Get URL
		var url = contents.match(/\<a href\=\"(.*?)\"/);
		var url = url[1];
		//Get Thumbnail
		var thumb_url = contents.match(/src\=\"(.*?)\"/);
		var thumb_url = thumb_url[1];
		//Title
		var title = contents.match(/class\=\"item\"\>(.*?)\<\/a\>/);
		var title = ImproveText(title[1]);
		//Length
		var length = contents.match(/valign\=\"middle\"\>Length\: (.*?) mins/);
		var length = TimestringToSeconds(length[1]);
		//Description
		var description = contents.match(/8pt;\"\>Added\: (.*?)\<\/td\>/);
		var description = splitTo2Lines("Added: " + ImproveText(description[1]), 60);
		//Views
		var views = contents.match(/8pt;\"\>Views\: (.*?)\<\/td\>/);
		var views = parseInt(views[1].replace(/,/g, ""));
		
		info = new Object();
		info.URL = url;
		info.ThumbnailURL = thumb_url;
		info.Title = title;
		info.LengthSeconds = length;
		info.Description = description;
		info.ViewCount = views;
		info.SaveFilename = ToFilename(title);
		info.attr = 7;
		result.VideoInfo.push( info );
		if(result.VideoInfo.length == perpage){break;}
		if(result.start + (result.VideoInfo.length - 1) == result.total){break;}
	} else{
		break;
	}
	}


	if(result.VideoInfo.length) {
		result.end = result.start + (result.VideoInfo.length - 1);
	} else {
		result.total = 0;	// no results.
	}

	if(result.VideoInfo.length != perpage){result.total = result.end;}

	return result;
}

// Service metadata
var WankTo = new Object();
WankTo.Name          = "Wank.To";		/* Service name */
WankTo.Description   = "Wank.To";		/* Service description */
WankTo.SearchDesc    = "Wank.To";		/* Service search screen description */
WankTo.SearchOSKMode = 1;			/* OSK mode 1: English only  2: Japanese */
WankTo.CheckURL      = WankTo_CheckURL;		/* CheckURL function */
WankTo.GetURL        = WankTo_GetURL;		/* GetURL function */
WankTo.Search        = WankTo_Search;		/* Search function */

// add Wank.To to site list
SiteList.push( WankTo );
